Index: /branches/version-2_5-dev/test/class/page/LC_Page_Admin_Products_ProductClass_Test.php
===================================================================
--- /branches/version-2_5-dev/test/class/page/LC_Page_Admin_Products_ProductClass_Test.php	(revision 18815)
+++ /branches/version-2_5-dev/test/class/page/LC_Page_Admin_Products_ProductClass_Test.php	(revision 18815)
@@ -0,0 +1,412 @@
+<?php
+/*
+ * This file is part of EC-CUBE
+ *
+ * Copyright(c) 2000-2010 LOCKON CO.,LTD. All Rights Reserved.
+ *
+ * http://www.lockon.co.jp/
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ */
+
+// {{{ requires
+require_once(realpath(dirname(__FILE__)) . '/../../require.php');
+require_once(realpath(dirname(__FILE__)) . '/../../../data/class/pages/admin/products/LC_Page_Admin_Products_ProductClass.php');
+
+/**
+ * LC_Page_Admin_Products_ProductClass のテストケース.
+ *
+ * @package Page
+ * @author Kentaro Ohkouchi
+ * @version $Id$
+ */
+class LC_Page_Admin_Products_ProductClass_Test extends PHPUnit_Framework_TestCase {
+
+    function setUp() {
+        $this->objQuery =& SC_Query::getSingletonInstance();
+        $this->objQuery->begin();
+
+        $this->objPage = new LC_Page_Admin_Products_ProductClass_Mock();
+        $this->objPage->init();
+        $this->now = "2010-01-01 00:00:00";
+    }
+
+    function tearDown() {
+        $this->objQuery->rollback();
+        $this->objQuery = null;
+        $this->objPage = null;
+    }
+
+    function testInit() {
+
+        $this->assertEquals('products/product_class.tpl',
+                            $this->objPage->tpl_mainpage);
+        $this->assertEquals('products/subnavi.tpl',
+                            $this->objPage->tpl_subnavi);
+        $this->assertEquals('products',
+                            $this->objPage->tpl_mainno);
+        $this->assertEquals('product',
+                            $this->objPage->tpl_subno);
+        $this->assertEquals('商品登録(商品規格)',
+                            $this->objPage->tpl_subtitle);
+    }
+
+    function testProcess() {
+        $this->objPage->process();
+    }
+
+    function testCreateSearchParams() {
+        $keys = array('search_product_id',
+                      'search_product_code',
+                      'search_category_id',
+                      'search_product_class_name',
+                      'search_name',
+                      'search_startyear',
+                      'search_startmonth',
+                      'search_startday',
+                      'search_endyear',
+                      'search_endmonth',
+                      'search_endday',
+                      'search_page_max',
+                      'search_pageno',
+                      'mode');
+        foreach ($keys as $key) {
+            $_POST[$key] = $key . " in value.";
+        }
+
+        $this->expected = array('search_product_id' => 'search_product_id in value.',
+                                'search_product_code' => 'search_product_code in value.',
+                                'search_category_id' => 'search_category_id in value.',
+                                'search_product_class_name' => 'search_product_class_name in value.',
+                                'search_name' => 'search_name in value.',
+                                'search_startyear' => 'search_startyear in value.',
+                                'search_startmonth' => 'search_startmonth in value.',
+                                'search_startday' => 'search_startday in value.',
+                                'search_endyear' => 'search_endyear in value.',
+                                'search_endmonth' => 'search_endmonth in value.',
+                                'search_endday' => 'search_endday in value.',
+                                'search_page_max' => 'search_page_max in value.',
+                                'search_pageno' => 'search_pageno in value.');
+
+        $this->actual = $this->objPage->createSearchParams($_POST);
+
+        $this->verify();
+    }
+
+    function testGetProductName() {
+        $product_id = 10000000;
+        $this->expected = "テスト商品";
+        $this->setProduct($product_id, $this->expected);
+
+        $this->actual = $this->objPage->getProductName($product_id);
+
+        $this->verify();
+    }
+
+    function testGetProductsClass() {
+        $product_id = 10000000;
+        $product_class_id = 10000;
+        $this->setProductsClass($product_id, $product_class_id);
+        $this->expected = array('product_class_id' => $product_class_id,
+                                'product_id' => $product_id,
+                                'class_combination_id' => null,
+                                'product_code' => 'product_code' . $product_class_id,
+                                'stock' => null,
+                                'stock_unlimited' => 0,
+                                'sale_unlimited' => 0,
+                                'sale_limit' => null,
+                                'price01' => 10000,
+                                'price02' => null,
+                                'deliv_fee' => null,
+                                'point_rate' => null,
+                                'status' => null,
+                                'creator_id' => 1,
+                                'create_date' => $this->now,
+                                'update_date' => null,
+                                'del_flg' => 0
+                                );
+
+        $this->actual = $this->objPage->getProductsClass($product_id);
+
+        $this->verify();
+    }
+
+    function testGetAllClass() {
+        $this->clearClass();
+        $this->setClass(1000, "大きさ", 1, array("S", "M", "L", "LL"));
+        $this->setClass(2, "色", 2, array("赤", "青", "黄", "緑"));
+        $this->setClass(3, "味", 3, array());
+
+        $this->expected = array("1000" => "大きさ",
+                                "2" => "色");
+        $this->actual = $this->objPage->getAllClass();
+
+        $this->verify();
+    }
+
+    function testGetAllClassCategory規格1のみ() {
+        $this->clearClass();
+        $this->setClass(1000, "大きさ", 1, array("S", "M", "L", "LL"));
+        $this->setClass(2, "色", 2, array("赤", "青", "黄", "緑"));
+        $this->setClass(3, "味", 3, array("甘口", "中辛", "辛口"));
+
+        $this->expected = array(
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000004,
+                                      "name1" => "LL",
+                                      "rank1" => 4),
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000003,
+                                      "name1" => "L",
+                                      "rank1" => 3),
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000002,
+                                      "name1" => "M",
+                                      "rank1" => 2),
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000001,
+                                      "name1" => "S",
+                                      "rank1" => 1));
+
+        $this->actual = $this->objPage->getAllClassCategory(1000);
+        $this->verify();
+    }
+
+    function testGetAllClassCategory規格1と3() {
+        $this->clearClass();
+        $this->setClass(1000, "大きさ", 1, array("S", "M", "L", "LL"));
+        $this->setClass(2, "色", 2, array("赤", "青", "黄", "緑"));
+        $this->setClass(3, "味", 3, array("甘口", "中辛", "辛口"));
+
+        $this->expected = array(
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000004,
+                                      "name1" => "LL",
+                                      "rank1" => 4,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000003,
+                                      "name2" => "辛口",
+                                      "rank2" => 3),
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000004,
+                                      "name1" => "LL",
+                                      "rank1" => 4,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000002,
+                                      "name2" => "中辛",
+                                      "rank2" => 2),
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000004,
+                                      "name1" => "LL",
+                                      "rank1" => 4,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000001,
+                                      "name2" => "甘口",
+                                      "rank2" => 1),
+
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000003,
+                                      "name1" => "L",
+                                      "rank1" => 3,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000003,
+                                      "name2" => "辛口",
+                                      "rank2" => 3),
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000003,
+                                      "name1" => "L",
+                                      "rank1" => 3,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000002,
+                                      "name2" => "中辛",
+                                      "rank2" => 2),
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000003,
+                                      "name1" => "L",
+                                      "rank1" => 3,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000001,
+                                      "name2" => "甘口",
+                                      "rank2" => 1),
+
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000002,
+                                      "name1" => "M",
+                                      "rank1" => 2,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000003,
+                                      "name2" => "辛口",
+                                      "rank2" => 3),
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000002,
+                                      "name1" => "M",
+                                      "rank1" => 2,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000002,
+                                      "name2" => "中辛",
+                                      "rank2" => 2),
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000002,
+                                      "name1" => "M",
+                                      "rank1" => 2,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000001,
+                                      "name2" => "甘口",
+                                      "rank2" => 1),
+
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000001,
+                                      "name1" => "S",
+                                      "rank1" => 1,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000003,
+                                      "name2" => "辛口",
+                                      "rank2" => 3),
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000001,
+                                      "name1" => "S",
+                                      "rank1" => 1,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000002,
+                                      "name2" => "中辛",
+                                      "rank2" => 2),
+                                array("class_id1" => 1000,
+                                      "classcategory_id1" => 1000000001,
+                                      "name1" => "S",
+                                      "rank1" => 1,
+                                      "class_id2" => 3,
+                                      "classcategory_id2" => 3000001,
+                                      "name2" => "甘口",
+                                      "rank2" => 1),
+                                );
+
+        $this->actual = $this->objPage->getAllClassCategory(1000, 3);
+        $this->verify();
+    }
+
+    function testGetProductsClassAndClasscategory() {
+        $product_id = 10000;
+        $product_class_id = 1000;
+        $class_combination_id = 200;
+        $this->clearClass();
+        $this->setClass(1000, "大きさ", 1, array("S", "M", "L", "LL"));
+        $this->setClass(2, "色", 2, array("赤", "青", "黄", "緑"));
+        $this->setClass(3, "味", 3, array("甘口", "中辛", "辛口"));
+        $this->setProductsClass($product_id, $product_class_id,
+                                $class_combination_id);
+        $this->setClassCombination($class_combination_id, 100, 3000001, 2);
+        $this->setClassCombination(100, null, 2000001, 1);
+
+
+        $this->expected = array(
+                                array("class_id1" => 2,
+                                      "class_id2" => 3,
+                                      "name1" => "赤",
+                                      "name2" => "甘口",
+                                      "rank1" => 1,
+                                      "rank2" => 1,
+                                      "product_class_id" => 1000,
+                                      "product_id" => 10000,
+                                      "classcategory_id1" => 2000001,
+                                      "classcategory_id2" => 3000001,
+                                      "product_code" => "product_code1000",
+                                      "stock" => null,
+                                      "stock_unlimited" => 0,
+                                      "sale_limit" => null,
+                                      "price01" => 10000,
+                                      "price02" => null));
+
+        $this->actual = $this->objPage->getProductsClassAndClasscategory($product_id);
+
+        $this->verify();
+    }
+
+    function verify() {
+        $this->assertEquals($this->expected, $this->actual);
+    }
+
+    function setProduct($product_id, $name) {
+        $val['product_id'] = $product_id;
+        $val['name'] = $name;
+        $val['creator_id'] = 1;
+        $val['deliv_date_id'] = 1;
+        $this->objQuery->insert("dtb_products", $val);
+    }
+
+    function setProductsClass($product_id, $product_class_id, $class_combination_id = null) {
+        $val['product_class_id'] = $product_class_id;
+        $val['product_id'] = $product_id;
+        $val['class_combination_id'] = $class_combination_id;
+        $val['product_code'] = 'product_code' . $product_class_id;
+        $val['price01'] = 10000;
+        $val['creator_id'] = 1;
+        $val['create_date'] = $this->now;
+        $val['del_flg'] = 0;
+        $this->objQuery->insert("dtb_products_class", $val);
+    }
+
+    function setClassCombination($class_combination_id,
+                                 $parent_class_combination_id, $classcategory_id,
+                                 $level) {
+        $val['class_combination_id'] = $class_combination_id;
+        $val['parent_class_combination_id'] = $parent_class_combination_id;
+        $val['classcategory_id'] = $classcategory_id;
+        $val['level'] = $level;
+        $this->objQuery->insert("dtb_class_combination", $val);
+    }
+
+    function clearClass() {
+        $this->objQuery->delete("dtb_class");
+        $this->objQuery->delete("dtb_classcategory");
+    }
+
+    /**
+     * 規格と規格分類を生成する.
+     *
+     * @param integer $class_id 規格ID
+     * @param string $class_name 規格名
+     * @param integer $rank 規格の表示順
+     * @param array $classcategory 規格分類名の配列
+     */
+    function setClass($class_id, $class_name, $rank, $classcategory) {
+        $val['class_id'] = $class_id;
+        $val['name'] = $class_name;
+        $val['creator_id'] = 1;
+        $val['del_flg'] = 0;
+        $val['rank'] = $rank;
+
+        $this->objQuery->insert("dtb_class", $val);
+        $i = 1;
+        foreach ($classcategory as $name) {
+            $val['classcategory_id'] = $class_id . "00000" . $i;
+            $val['name'] = $name;
+            $val['rank'] = $i;
+            $this->objQuery->insert("dtb_classcategory", $val);
+            $i++;
+        }
+    }
+}
+
+class LC_Page_Admin_Products_ProductClass_Mock extends LC_Page_Admin_Products_ProductClass {
+
+    function authorization() {
+        // quiet.
+    }
+
+    function assignView() {
+        // quiet.
+    }
+}
+?>
Index: /branches/version-2_5-dev/html/install/sql/create_view.sql
===================================================================
--- /branches/version-2_5-dev/html/install/sql/create_view.sql	(revision 18777)
+++ /branches/version-2_5-dev/html/install/sql/create_view.sql	(revision 18815)
@@ -1,73 +1,9 @@
-CREATE VIEW vw_cross_class as
-    SELECT
-        T1.class_id AS class_id1,
-        T2.class_id AS class_id2,
-        T1.classcategory_id AS classcategory_id1,
-        T2.classcategory_id AS classcategory_id2,
-        T1.name AS name1,
-        T2.name AS name2,
-        T1.rank AS rank1,
-        T2.rank AS rank2
-    FROM
-        dtb_classcategory AS T1,
-        dtb_classcategory AS T2
-;
-
-CREATE VIEW vw_cross_products_class AS
-    SELECT
-        T1.class_id1,
-        T1.class_id2,
-        T1.classcategory_id1,
-        T1.classcategory_id2,
-        T2.product_id,
-        T1.name1,
-        T1.name2,
-        T2.product_code,
-        T2.stock,
-        T2.price01,
-        T2.price02,
-        T1.rank1,
-        T1.rank2
-    FROM
-        vw_cross_class AS T1
-        LEFT JOIN dtb_products_class AS T2
-            ON T1.classcategory_id1 = T2.classcategory_id1
-            AND T1.classcategory_id2 = T2.classcategory_id2
-;
-
-CREATE VIEW vw_products_nonclass AS
-    SELECT *
-    FROM
-        dtb_products AS T1
-        LEFT JOIN
-        (
-            SELECT
-                product_id AS product_id_sub,
-                product_code,
-                price01,
-                price02,
-                stock,
-                stock_unlimited,
-                classcategory_id1,
-                classcategory_id2
-            FROM dtb_products_class
-            WHERE
-                classcategory_id1 = 0
-                AND classcategory_id2 = 0
-        ) AS T2
-        ON T1.product_id = T2.product_id_sub
-;
-
 CREATE VIEW vw_products_allclass_detail AS
     SELECT
         dtb_products.product_id,
         dtb_products."name",
-        dtb_products.deliv_fee,
-        dtb_products.sale_limit,
         dtb_products.maker_id,
         dtb_products.rank,
         dtb_products.status,
-        dtb_products.product_flag,
-        dtb_products.point_rate,
         dtb_products.comment1,
         dtb_products.comment2,
@@ -169,55 +105,2 @@
             ON T2.category_id = dtb_category.category_id
 ;
-
-CREATE VIEW vw_product_class AS
-     SELECT *
-       FROM
-      (SELECT T3.product_class_id,
-              T3.product_id AS product_id_sub,
-              classcategory_id1,
-              classcategory_id2,
-              T3.rank AS rank1,
-              T4.rank AS rank2,
-              T3.class_id AS class_id1,
-              T4.class_id AS class_id2,
-              stock,
-              price01,
-              price02,
-              stock_unlimited,
-              product_code
-         FROM (dtb_products_class AS T1
-    LEFT JOIN dtb_classcategory AS T2
-           ON T1.classcategory_id1 = T2.classcategory_id) AS T3
-  LEFT JOIN dtb_classcategory AS T4
-         ON T3.classcategory_id2 = T4.classcategory_id) AS T5
-  LEFT JOIN dtb_products AS T6
-         ON product_id_sub = T6.product_id;
-
-CREATE VIEW vw_category_count AS
-     SELECT T1.category_id,
-            T1.category_name,
-            T1.parent_category_id,
-            T1.level,
-            T1.rank,
-            T2.product_count
-       FROM dtb_category AS T1
-  LEFT JOIN dtb_category_total_count AS T2
-         ON T1.category_id = T2.category_id
-;
-
-CREATE VIEW vw_download_class as
-     SELECT
-          p.product_id AS product_id,
-          p.down_realfilename AS down_realfilename,
-          p.down_filename AS down_filename,
-          od.order_id AS order_id,
-          o.customer_id AS customer_id,
-          o.commit_date AS commit_date,
-          o.status AS status
-     FROM
-          dtb_products p,
-          dtb_order_detail od,
-          dtb_order o
-     WHERE
-          p.product_id = od.product_id AND
-          od.order_id = o.order_id;
Index: /branches/version-2_5-dev/html/install/sql/drop_view.sql
===================================================================
--- /branches/version-2_5-dev/html/install/sql/drop_view.sql	(revision 18787)
+++ /branches/version-2_5-dev/html/install/sql/drop_view.sql	(revision 18815)
@@ -1,8 +1,2 @@
-DROP VIEW vw_category_count;
-DROP VIEW vw_product_class;
 DROP VIEW vw_products_allclass;
 DROP VIEW vw_products_allclass_detail;
-DROP VIEW vw_products_nonclass;
-DROP VIEW vw_cross_products_class;
-DROP VIEW vw_cross_class;
-DROP VIEW vw_download_class;
Index: /branches/version-2_5-dev/html/install/sql/create_table_mysql.sql
===================================================================
--- /branches/version-2_5-dev/html/install/sql/create_table_mysql.sql	(revision 18791)
+++ /branches/version-2_5-dev/html/install/sql/create_table_mysql.sql	(revision 18815)
@@ -256,13 +256,8 @@
 CREATE TABLE dtb_products (
     product_id int  NOT NULL,
-    name text,
-    deliv_fee numeric,
-    sale_limit numeric,
-    category_id int,
+    name text NOT NULL,
     maker_id int,
     rank int,
     status smallint NOT NULL DEFAULT 2,
-    product_flag text,
-    point_rate numeric,
     comment1 text,
     comment2 text,
@@ -312,5 +307,5 @@
     update_date datetime,
     deliv_date_id int,
-    down smallint NOT NULL ,
+    down smallint NOT NULL DEFAULT 0,
     down_filename text,
     down_realfilename text,
@@ -321,16 +316,19 @@
     product_class_id int  NOT NULL,
     product_id int NOT NULL,
-    classcategory_id1 int NOT NULL DEFAULT 0,
-    classcategory_id2 int NOT NULL DEFAULT 0,
+    class_combination_id int,
     product_code text,
     stock numeric,
     stock_unlimited smallint NOT NULL DEFAULT 0,
     sale_limit numeric,
+    sale_unlimited smallint NOT NULL DEFAULT 0,
     price01 numeric,
     price02 numeric,
+    deliv_fee numeric,
+    point_rate numeric,
     status smallint,
     creator_id int NOT NULL,
     create_date datetime NOT NULL,
     update_date datetime,
+    del_flg smallint NOT NULL DEFAULT 0,
     PRIMARY KEY (product_class_id)
 ) TYPE=InnoDB;
@@ -345,5 +343,4 @@
     update_date datetime,
     del_flg smallint NOT NULL DEFAULT 0,
-    product_id int,
     PRIMARY KEY (class_id)
 ) TYPE=InnoDB;
@@ -360,4 +357,12 @@
     del_flg smallint NOT NULL DEFAULT 0,
     PRIMARY KEY (classcategory_id)
+) TYPE=InnoDB;
+
+CREATE TABLE dtb_class_combination (
+    class_combination_id int NOT NULL,
+    parent_class_combination_id int,
+    classcategory_id int NOT NULL,
+    level int,
+    PRIMARY KEY(class_combination_id)
 ) TYPE=InnoDB;
 
@@ -380,4 +385,14 @@
     rank int NOT NULL,
     PRIMARY KEY(product_id, category_id)
+) TYPE=InnoDB;
+
+CREATE TABLE dtb_product_status (
+    product_status_id smallint NOT NULL,
+    product_id int NOT NULL,
+    creator_id int NOT NULL,
+    create_date datetime NOT NULL,
+    update_date datetime,
+    del_flg smallint NOT NULL DEFAULT 0,
+    PRIMARY KEY(product_status_id, product_id)
 ) TYPE=InnoDB;
 
Index: /branches/version-2_5-dev/html/install/sql/create_table_pgsql.sql
===================================================================
--- /branches/version-2_5-dev/html/install/sql/create_table_pgsql.sql	(revision 18791)
+++ /branches/version-2_5-dev/html/install/sql/create_table_pgsql.sql	(revision 18815)
@@ -256,13 +256,8 @@
 CREATE TABLE dtb_products (
     product_id int NOT NULL,
-    name text,
-    deliv_fee numeric,
-    sale_limit numeric,
-    category_id int,
+    name text NOT NULL,
     maker_id int,
     rank int,
     status smallint NOT NULL DEFAULT 2,
-    product_flag text,
-    point_rate numeric,
     comment1 text,
     comment2 text,
@@ -312,5 +307,5 @@
     update_date timestamp,
     deliv_date_id int,
-    down int2 NOT NULL ,
+    down smallint NOT NULL DEFAULT 0,
     down_filename text,
     down_realfilename text,
@@ -321,16 +316,19 @@
     product_class_id int NOT NULL,
     product_id int NOT NULL,
-    classcategory_id1 int NOT NULL DEFAULT 0,
-    classcategory_id2 int NOT NULL DEFAULT 0,
+    class_combination_id int,
     product_code text,
     stock numeric,
     stock_unlimited smallint NOT NULL DEFAULT 0,
     sale_limit numeric,
+    sale_unlimited smallint NOT NULL DEFAULT 0,
     price01 numeric,
     price02 numeric,
+    deliv_fee numeric,
+    point_rate numeric,
     status smallint,
     creator_id int NOT NULL,
     create_date timestamp NOT NULL DEFAULT now(),
     update_date timestamp,
+    del_flg smallint NOT NULL DEFAULT 0,
     PRIMARY KEY (product_class_id)
 );
@@ -345,5 +343,4 @@
     update_date timestamp,
     del_flg smallint NOT NULL DEFAULT 0,
-    product_id int,
     PRIMARY KEY (class_id)
 );
@@ -360,4 +357,12 @@
     del_flg smallint NOT NULL DEFAULT 0,
     PRIMARY KEY (classcategory_id)
+);
+
+CREATE TABLE dtb_class_combination (
+    class_combination_id int NOT NULL,
+    parent_class_combination_id int,
+    classcategory_id int NOT NULL,
+    level int,
+    PRIMARY KEY (class_combination_id)
 );
 
@@ -381,4 +386,15 @@
     PRIMARY KEY(product_id, category_id)
 );
+
+CREATE TABLE dtb_product_status (
+    product_status_id smallint NOT NULL,
+    product_id int NOT NULL,
+    creator_id int NOT NULL,
+    create_date timestamp NOT NULL DEFAULT now(),
+    update_date timestamp,
+    del_flg smallint NOT NULL DEFAULT 0,
+    PRIMARY KEY (product_status_id, product_id)
+);
+
 
 CREATE TABLE dtb_bat_order_daily (
Index: /branches/version-2_5-dev/html/install/sql/drop_table.sql
===================================================================
--- /branches/version-2_5-dev/html/install/sql/drop_table.sql	(revision 18791)
+++ /branches/version-2_5-dev/html/install/sql/drop_table.sql	(revision 18815)
@@ -13,6 +13,8 @@
 DROP TABLE dtb_products;
 DROP TABLE dtb_products_class;
+DROP TABLE dtb_product_status;
 DROP TABLE dtb_class;
 DROP TABLE dtb_classcategory;
+DROP TABLE dtb_class_combination;
 DROP TABLE dtb_category;
 DROP TABLE dtb_product_categories;
Index: /branches/version-2_5-dev/html/install/index.php
===================================================================
--- /branches/version-2_5-dev/html/install/index.php	(revision 18794)
+++ /branches/version-2_5-dev/html/install/index.php	(revision 18815)
@@ -972,4 +972,5 @@
                  array("dtb_products_class", "product_class_id"),
                  array("dtb_products", "product_id"),
+                 array("dtb_class_combination", "class_combination_id"),
                  array("dtb_review", "review_id"),
                  array("dtb_send_history", "send_id"),
